 	
	.include	"basic_vu.i"
	.include	"spad.i"
	.include	"demu.i"
	.include	"vumacros.m"
	
 	--enter
	--endenter

	iaddiu		count,vi00,NUM_FISH
	iaddiu		up_p,vi00,sp_sizeof
	iaddiu		fi_p,vi00,sp_fishTable


	lq.w		vmax,sp_cosRcpVals(vi0)
	lq.w		vmin,sp_cosMinVals(vi0)

	loi		1.0/60.0
u2_loop:
	--LoopCS	3,3

;	read info

	lqi		update,(up_p++)
	lq.xyz		pos,fi_pos(fi_p)
	lq		ahead,fi_ahead(fi_p)

	div		q,vf00[w],update[w]	

	mul.xyz		acc,ahead,ahead[w]	 ; acc = old_velocity
	madd.xyz	vel,update,q		; vel = update velocity

	; normlen 

	mul.xyz 	tmp,vel,vel
	move.xyz	new_ahead,vel			; norm.xyz = vec

	mul.w		acc,vf00,tmp[x]
	madd.w 		acc,vf00,tmp[y]
	madd.w		new_ahead,vf00,tmp[z] 	; norm.w = |vec|^2
	rsqrt		q,vf00[w],new_ahead[w]  	
	mul		new_ahead,new_ahead,q			; norm.w= |vec|

	
;	clamp new velocity

	mini.w		new_ahead,new_ahead,vmax
	max.w		new_ahead,new_ahead,vmin

;	update position
	
	mul.w		tmp,new_ahead,i

	mul.xyz		acc,new_ahead,tmp[w]
	madd.xyz	new_pos,pos,vf00[w]


	sq.xyz		new_pos,fi_pos(fi_p)
	sq		new_ahead,fi_ahead(fi_p)


	iaddi		count,count,-1
	iaddiu		fi_p,fi_p,fi_sizeof

	ibne		count,vi00,u2_loop






	--exitm
	--endexit


